package cn.com.ty.lift.business.emergency.controller;


import cn.com.ty.lift.business.emergency.dto.RepairCost;
import cn.com.ty.lift.business.emergency.entity.ErCostItem;
import cn.com.ty.lift.business.emergency.service.ErCostItemService;
import cn.com.xwy.boot.web.dto.RestResponse;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wcz
 * @since 2019-12-04
 */
@AllArgsConstructor
@RestController
@RequestMapping("/emergency/er-cost-item")
public class ErCostItemController {

    private ErCostItemService erCostItemService;

    /**
     * @description 新增急修收费单项
     * @date 2019/12/9 17:23
     * @param
     * @return
     */
    @PostMapping("add")
    public RestResponse add(@RequestBody RepairCost repairCost){
        Long erRecordId = repairCost.getErRecordId();
        List<ErCostItem> items = repairCost.getItems();
        if(erRecordId == null || null == items || items.size() <= 0){
            return RestResponse.failParam();
        }
        for (ErCostItem item: items){
            item.setErRecordId(erRecordId);
        }
        boolean result = erCostItemService.saveBatch(items);
        if(result){
            return RestResponse.success(result);
        }
        return RestResponse.fail();
    }

    @PostMapping("delete")
    public RestResponse delete(Long id){
        if(null == id || id <= 0){
            return RestResponse.failParam();
        }
        boolean result = erCostItemService.removeById(id);
        if(result){
            return RestResponse.success(result);
        }
        return RestResponse.fail();
    }

    @PostMapping("modify")
    public RestResponse modify(@RequestBody List<ErCostItem> entityList){
        if(null == entityList || entityList.size() == 0){
            return RestResponse.failParam();
        }
        boolean result = erCostItemService.updateBatchById(entityList);
        if(result){
            return RestResponse.success(result);
        }
        return RestResponse.fail();
    }
}
