package cn.com.ty.lift.business.emergency.service;

import cn.com.ty.lift.business.emergency.dto.RepairRequest;
import cn.com.ty.lift.business.emergency.dto.RepairResponse;
import cn.com.ty.lift.business.emergency.entity.EmergencyRepair;
import cn.com.ty.lift.business.emergency.mapper.EmergencyRepairMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 临修记录 服务实现类
 * </p>
 *
 * @author wcz
 * @since 2019-12-04
 */
@Service
public class EmergencyRepairService extends ServiceImpl<EmergencyRepairMapper, EmergencyRepair> {

    /**
     * 分页查询急修中的急修记录
     * @param request
     * @return
     */
    public IPage<RepairResponse> pageByRepairing(RepairRequest request) {
        long pageSize = request.getPageSize();
        long pageNum = request.getPageNum();
        IPage<RepairResponse>  page = new Page<>(pageNum,pageSize);
        baseMapper.pageByRepairing(page,request);
        return page;
    }

    /**
     * 根据条件分页查询急修记录
     * @param request
     * @return
     */
    public IPage<RepairResponse> pageByCondition(RepairRequest request) {
        long pageNum = request.getPageNum();
        long pageSize = request.getPageSize();
        IPage<RepairResponse> page = new Page<>(pageNum,pageSize);
        return baseMapper.pageByCondition(page,request);
    }

    /**
     * 根据条件统计急修记录总条数
     * @param request
     * @return
     */
    public long countByCondition(RepairRequest request) {
        return baseMapper.countByCondition(request);
    }

    /**
     * 根据id查询急修记录，带关联信息
     * @param request
     * @return
     */
    public RepairResponse selectByIdWithInfo(RepairRequest request) {
        return baseMapper.selectByIdWithInfo(request);
    }

    public IPage<RepairResponse> pageByUser(RepairRequest request) {
        long pageNum = request.getPageNum();
        long pageSize = request.getPageSize();
        IPage<RepairResponse> page = new Page<>(pageNum,pageSize);
        return baseMapper.pageByUser(page,request);
    }
}
